base @
1 1 + 0 pick + 1 + 0 pick + base !
: immediate 1 last @ 12 + c! ;
: \ 256 word drop ; immediate

\ The above lines saved the current base on the stack, set the base to decimal
\ and implemented the immediate and \ words.  The base is set to decimal
\ using only 0's and 1's because the original base could be as low as 2.

\ DEFINE CELL SIZE
: cellsize 4 ;
: cellmask 3 ;

\ BASIC STACK WORDS
: dup 0 pick ;
: rot 2 roll ;
: swap 1 roll ;
: over 1 pick ;
: 2dup over over ;
: 2drop drop drop ;
: 2swap 3 roll 3 roll ;
: 2over 3 pick 3 pick ;

\ DEFINE BASIC WORD BUILDERS
: here dp @ ;
: allot dp @ + dp ! ;
: source tib #tib @ ;
: , here ! cellsize allot ;
: compile, , ;
: ' 32 word find 0 = 0 = and ;
: _does r> dup >r 8 + last @ 8 + ! ;
: _setjmp 10 last @ 12 + c! ;
: >body 13 + dup c@ + 4 + -4 and ;
: literal 0 , , ; immediate 
  last @ >body dup @ swap 4 + ! \ Patch in address of _lit
: postpone ' , ; immediate
: ['] ' postpone literal ; immediate
: [compile] ' postpone literal ['] , , ; immediate
: does> [compile] _does [compile] exit ; immediate

\ CONDITIONAL EXECUTION AND LOOPING
: _jmp r> 4 + @ >r ; _setjmp
: _jz  r> 4 + dup @ rot 0 = 1 + pick >r drop drop ; _setjmp
: if ['] _jz , here >r 4 allot ; immediate
: else ['] _jmp , here r> ! here >r 4 allot ; immediate
: then here 4 - r> ! ; immediate
: begin here 4 - >r ; immediate
: until ['] _jz , r> , ; immediate
: again ['] _jmp , r> , ; immediate
: while ['] _jz , here >r 4 allot ; immediate
: repeat ['] _jmp ,  here r> ! r> , ; immediate
: i r> r> dup >r swap >r ;
: j r> r> r> r> dup >r swap >r swap >r swap >r ;
: do  ['] _lit , here >r 4 allot ['] drop ,
      ['] swap , ['] >r , ['] >r , here 4 - >r ; immediate
: ?do ['] 2dup , ['] > , ['] _jz , here >r 4 allot
      ['] swap , ['] >r , ['] >r , here 4 - >r ; immediate
: _loop r> swap r> + r> dup >r swap dup >r > 0 = swap >r ;
: loop ['] _lit , 1 , ['] _loop , ['] _jz , r> , ['] r> , ['] r> , here 4 - r> ! ['] 2drop , ; immediate
: +loop ['] _loop , ['] _jz , r> , ['] r> , ['] r> , here 4 - r> ! ['] 2drop , ; immediate
: leave r> drop r> dup >r >r ;

\ DEFINE "(" COMMENT WORD NOW THAT WE CAN loop
: ( begin
      #tib @ >in @
      ?do tib i + c@ 41 = if i 1 + >in ! r> r> drop drop exit then loop
      refill 0 =
    until ; immediate

( PAD AND PRINT SUPPORT )
create pad 256 allot
create printptr 4 allot
: d2a dup 10 < if 48 else 55 then + ;
: a2d dup 48 < if drop -1 else dup 57 > if drop -1 else 48 - then then ;
: c!-- dup >r c! r> 1 - ;
: cprint printptr @ c! printptr @ 1 - printptr ! ;

( CORE WORDS )
: +! dup @ swap + swap ! ;
: /mod over over >r >r mod r> r> / ;
: [ state 0 ! ;
: ] state 1 ! ;
: r@ r> dup >r ;
: s>d dup 0 < ;
: sm/rem >r 2dup r@ s>d d/ drop r> swap >r s>d dmod drop r> ;
: um/mod >r 2dup r@ s>d ud/ drop r> swap >r s>d udmod drop r> ;
: fm/mod over over xor -2147483648 and if sm/rem else sm/rem then ; ( TOdo )
: */mod >r m* r> sm/rem ;
: */ */mod swap drop ;
: <# pad 255 + printptr ! ;
: hold cprint ;
: # over over base @ 0 udmod drop d2a cprint base @ 0 d/ ;
: #s begin # over over or 0 = until ;
: #> drop drop printptr @ 1 + dup pad 256 + swap - ;
: sign 0 < if 45 hold then ;
: abs dup 0 < if 0 swap - then ;
: type 0 ?do dup c@ emit 1 + loop drop ;
: ._ dup abs 0 <# #s rot sign #> type ;
: . ._ 32 emit ;
: >number dup 0 ?do >r dup c@ a2d dup 0 < if drop r> leave else swap >r >r
  base @ 0 d* r> 0 d+ r> 1 + r> 1 - then loop ;
: 0= 0 = ;
: 0< 0 < ;
: 1+ 1 + ;
: 1- 1 - ;
: 2! swap over ! cellsize + ! ;
: 2* dup + ;
: 2/ dup -2147483648 and swap 1 rshift or ;
: 2@ dup cellsize + @ swap @ ;
: ?dup dup if dup then ;
: aligned cellmask + 0 cellsize - and ;
: align here aligned here - allot ;
: bl 32 ;
: c, here c! 1 allot ;
: cell+ cellsize + ;
: cells cellsize * ;
: char+ 1 + ;
: chars ;
: count dup char+ swap c@ ;
: char 32 word count 0= if drop 0 else c@ then ;
: [char] char postpone literal ; immediate
: constant create here ! cellsize allot does> @ ;
: cr 13 emit 10 emit ;
: decimal 10 base ! ;
: environment? drop drop 0 ;
: fill swap >r swap r> 0 ?do 2dup C! 1 + loop 2drop ;
: hex 16 base ! ;
: invert -1 xor ;
: max 2dup < if swap then drop ;
: min 2dup > if swap then drop ;
: cmove >r swap r> 0 ?do 2dup c@ swap c! 1+ swap 1+ swap loop 2drop ;
: cmove> >r swap r> dup >r 1- dup >r + swap r> + swap r> ?do 2dup c@ swap c!
  1- swap 1- swap loop 2drop ;
: move r> 2dup > if r> cmove else r> cmove> then ;
: negate 0 swap - ;
: recurse last @ , ; immediate
: _lit" r> 4 + dup 1 + swap dup c@ dup -4 and rot + >r ;
4 last @ 12 + c! ( Set STRING flag )
: s" ['] _lit" , [char] " word count dup >r dup >r c, here r> cmove r> allot
  align ; immediate
: ." postpone s" ['] type , ; immediate
: _abort" if type abort else drop drop then ;
: abort" postpone s" ['] _abort" , ; immediate
: space 32 emit ;
: spaces 0 ?do space loop ;
: u._ 0 <# #s #> type ;
: u. u._ 32 emit ;
: u< over over xor -2147483648 and if swap then < ;
: unloop r> drop r> drop ;
: variable create cellsize allot ;

( CORE EXT )
: 0<> 0= invert ;
: 0> 0 > ;
: 2>r swap >r >r ;
: 2r> r> r> swap ;
: 2r@ r> r> 2dup >r >r swap ;
: <> = 0= ;
: erase 0 ?do dup 0 swap ! 1 + loop drop ;
: false 0 ;
: marker create last @ , does> @ dup dp ! @ last ! ;
: nip swap drop ;
: true -1 ;
: tuck swap over ;
: value create here ! cellsize allot does> @ ;
: within over - >r - r> u< ;
: .r_ >r dup abs 0 <# #s rot sign #> dup r> swap - spaces type ;
: .r .r_ 32 emit ;
: u.r_ >r 0 <# #s #> dup r> swap - spaces type ;
: u.r .r_ 32 emit ;
: u> over over xor -2147483648 and if swap then > ;

( DOUBLE )
: d= rot = rot rot = and ;
: d0= or 0 = ;
: 2constant create swap , , does> dup @ swap cellsize + @ ;

( STRING )
: blank 0 ?do dup bl swap c! 1+ loop drop ;
: -trailing dup 0 ?do 2dup + 1- c@ bl = if 1- else leave then loop ;

( TOOLS )
: ? @ . ;
: .s 60 emit depth ._ 62 emit 32 emit depth 0 ?do depth i - 1 - pick . loop ;
: dump 0 ?do i 15 and 0 = if cr dup . then dup c@ 3 .r 1 + loop drop cr ;
: forget 32 word find if dup dp ! @ last ! else abort" ?" then ;
: .name dup 13 + count type space ;
: ?newline dup >r 13 + c@ dup rot + 1 + dup 78 > if cr else swap then drop r> ;
: words 0 last @ begin dup while ?newline .name @ repeat 2drop ;

base ! ( Restore base to original value )
