#ifdef __PROPELLER__
#include <propeller.h>
//#define FAST __attribute__((section(".hubtext")))
#define FAST
#if defined(__PROPELLER_CMM__) || defined(__PROPELLER_LMM__)
#define CODE_SIZE  750
#define STACK_SIZE  50
#else
#define CODE_SIZE 3000
#define STACK_SIZE 100
#endif
#else
#define FAST
#define CODE_SIZE 20000
#define STACK_SIZE 1000
#endif

#define FLAG_IMMEDIATE 1
#define FLAG_LITERAL   2
#define FLAG_STRING    4
#define FLAG_JUMP      8

#define RETURN_NORMAL  2
#define RETURN_EXIT    1
#define RETURN_QUIT    0
#define RETURN_ERROR  -1
#define RETURN_BYE    -2

#define ALIGN(ptr) ((void *)((((int)(ptr)) + 3) & ~3))
#define BODY(wordentry) ALIGN(wordentry->name + wordentry->len)
#define EXECUTE(wordentry) (wordentry->func)(wordentry)

typedef int (*wordfuncP)(void *);

typedef struct dictentryS {
    struct dictentryS *prev;
    wordfuncP func;
    int *does;
    unsigned char flags;
    unsigned char len;
    char name[1];
} dictentryT;

void pushret(int value);
int popret(void);
void push(int value);
int pop(void);
int64_t pop2(void);
void push2(int64_t value);
char *Word(int *num);
char *WordDelimiter(int *num, int delimiter);
dictentryT *FindWord(char *name, int len);
int ExecuteWordList(int *listaddr);
void Create(char *name, int len, wordfuncP wordfunc);
void Include(char *fname);
int Evaluate(void);
void Type(char *str, int len);
void CompileString(void *parm);
void RemoveCRLF(char *ptr);
char getch(void);
int Refill(void);

int codespace[CODE_SIZE];
char *here;
dictentryT *lastword;
dictentryT *storeword;
dictentryT *_jmpword;
dictentryT *_jzword;
dictentryT *_litword;
dictentryT *_litquoteword;
int stack[STACK_SIZE];
int stkidx;
FILE *inputfile;
char *inputptr;
int inputlen;
int inputidx;
int compileflag;
char *instack[20];
int inidx;
int retstk[STACK_SIZE];
int retidx;
int *execaddr;
int base;
int errorcode;
int evaluate;
